searchNodes=[{"type":"module","title":"Circuits.I2C","doc":"Circuits.I2C lets you communicate with hardware devices using the I2C protocol.","ref":"Circuits.I2C.html"},{"type":"function","title":"Circuits.I2C.bus_names/0","doc":"Return a list of available I2C bus names. If nothing is returned, it's possible that the kernel driver for that I2C bus is not enabled or the kernel's device tree is not configured. On Raspbian, run raspi-config and look in the advanced options. iex&gt; Circuits.I2C . bus_names ( ) [ &quot;i2c-1&quot; ]","ref":"Circuits.I2C.html#bus_names/0"},{"type":"function","title":"Circuits.I2C.close/1","doc":"close the I2C bus","ref":"Circuits.I2C.html#close/1"},{"type":"function","title":"Circuits.I2C.detect_devices/0","doc":"Convenience method to scan all I2C buses for devices This is only intended to be called from the IEx prompt. Programs should use detect_devices/1 .","ref":"Circuits.I2C.html#detect_devices/0"},{"type":"function","title":"Circuits.I2C.detect_devices/1","doc":"Scan the I2C bus for devices by performing a read at each device address and returning a list of device addresses that respond. WARNING: This is intended to be a debugging aid. Reading bytes from devices can advance internal state machines and might cause them to get out of sync with other code. iex&gt; Circuits.I2C . detect_devices ( &quot;i2c-1&quot; ) [ 4 ] The return value is a list of device addresses that were detected on the specified I2C bus. If you get back 'Hh' or other letters, then IEx converted the list to an Erlang string. Run i v() to get information about the return value and look at the raw string representation for addresses. If you already have opened an I2C bus, then you may pass it to detect_devices/1 instead.","ref":"Circuits.I2C.html#detect_devices/1"},{"type":"function","title":"Circuits.I2C.device_present?/2","doc":"Return whether a device is present This function performs a simplistic check for an I2C device on the specified bus and address. It's not perfect, but works enough to be useful. Be warned that it does perform an I2C read on the specified address and this may cause some devices to actually do something.","ref":"Circuits.I2C.html#device_present?/2"},{"type":"function","title":"Circuits.I2C.discover/2","doc":"Scan all I2C buses for one or more devices This function takes a list of possible addresses and an optional detection function. It only scans addresses in the possible addresses list to avoid disturbing unrelated I2C devices. If a detection function is not passed in, a default one that performs a simple read and checks whether it succeeds is used. If the desired device has an ID register or other means of identification, the optional function should try to query that. If passing a custom function, be sure to return false rather than raise if there are errors. A list of bus name and address tuples is returned. The list may be empty. See also discover_one/2 .","ref":"Circuits.I2C.html#discover/2"},{"type":"function","title":"Circuits.I2C.discover_one/2","doc":"Scans all I2C buses for one specific device This function and discover_one!/2 are convenience functions for the use case of helping a user find a specific device. They both call discover/2 with a list of possible I2C addresses and an optional function for checking whether the device is present. This function returns an :ok or :error tuple depending on whether one and only one device was found. See discover_one!/2 for the raising version.","ref":"Circuits.I2C.html#discover_one/2"},{"type":"function","title":"Circuits.I2C.discover_one!/2","doc":"Same as discover_one/2 but raises on error","ref":"Circuits.I2C.html#discover_one!/2"},{"type":"function","title":"Circuits.I2C.info/1","doc":"Return info about the low level I2C interface This may be helpful when debugging I2C issues.","ref":"Circuits.I2C.html#info/1"},{"type":"function","title":"Circuits.I2C.open/2","doc":"Open an I2C bus I2C bus names depend on the platform. Names are of the form &quot;i2c-n&quot; where the &quot;n&quot; is the bus number. The correct bus number can be found in the documentation for the device or on a schematic. Another option is to call Circuits.I2C.bus_names/0 to list them for you. The same I2C bus may be opened more than once. There is no need to share it between modules. On success, this returns a Circuits.I2C.Bus.t() struct for accessing the I2C bus. Use this in subsequent calls to read and write I2C devices. Options depend on the backend. The following are for the I2CDev (default) backend: :retries - the default number of retries to automatically do on reads and writes (defaults to no retries)","ref":"Circuits.I2C.html#open/2"},{"type":"function","title":"Circuits.I2C.read/4","doc":"Initiate a read transaction to the I2C device at the specified address Options: :retries - number of retries before failing (defaults to no retries)","ref":"Circuits.I2C.html#read/4"},{"type":"function","title":"Circuits.I2C.read!/4","doc":"Initiate a read transaction and raise on error","ref":"Circuits.I2C.html#read!/4"},{"type":"function","title":"Circuits.I2C.write/4","doc":"Write data to the I2C device at address . Options: :retries - number of retries before failing (defaults to no retries)","ref":"Circuits.I2C.html#write/4"},{"type":"function","title":"Circuits.I2C.write!/4","doc":"Write data to the I2C device at address and raise on error Options: :retries - number of retries before failing (defaults to no retries)","ref":"Circuits.I2C.html#write!/4"},{"type":"function","title":"Circuits.I2C.write_read/5","doc":"Write data to an I2C device and then immediately issue a read. This function is useful for devices that want you to write the &quot;register&quot; location to them first and then issue a read to get its contents. Many devices operate this way and this function will issue the commands back-to-back on the I2C bus. Some I2C devices actually require that the read immediately follows the write. If the target supports this, the I2C transaction will be issued that way. On the Raspberry Pi, this can be enabled globally with File.write!(&quot;/sys/module/i2c_bcm2708/parameters/combined&quot;, &quot;1&quot;) Options: :retries - number of retries before failing (defaults to no retries)","ref":"Circuits.I2C.html#write_read/5"},{"type":"function","title":"Circuits.I2C.write_read!/5","doc":"Write data to an I2C device and then immediately issue a read. Raise on errors. Options: :retries - number of retries before failing (defaults to no retries)","ref":"Circuits.I2C.html#write_read!/5"},{"type":"type","title":"Circuits.I2C.address/0","doc":"I2C device address This is a &quot;7-bit&quot; address for the device. Some devices specify an &quot;8-bit&quot; address in their documentation. You can tell if you have an &quot;8-bit&quot; address if it's greater than 127 (0x7f) or if the documentation talks about different read and write addresses. If you have an 8-bit address, divide it by 2.","ref":"Circuits.I2C.html#t:address/0"},{"type":"type","title":"Circuits.I2C.backend/0","doc":"Backends specify an implementation of a Circuits.I2C.Backend behaviour The second parameter of the Backend 2-tuple is a list of options. These are passed to the behaviour function call implementations.","ref":"Circuits.I2C.html#t:backend/0"},{"type":"type","title":"Circuits.I2C.opt/0","doc":"","ref":"Circuits.I2C.html#t:opt/0"},{"type":"type","title":"Circuits.I2C.present?/0","doc":"Function to report back whether a device is present See discover/2 for how a custom function can improve device detection when the type of device being looked for is known.","ref":"Circuits.I2C.html#t:present?/0"},{"type":"behaviour","title":"Circuits.I2C.Backend","doc":"Backends provide the connection to the real or virtual I2C controller","ref":"Circuits.I2C.Backend.html"},{"type":"callback","title":"Circuits.I2C.Backend.bus_names/1","doc":"Return the I2C bus names on this system No supported options","ref":"Circuits.I2C.Backend.html#c:bus_names/1"},{"type":"callback","title":"Circuits.I2C.Backend.info/0","doc":"Return information about this backend","ref":"Circuits.I2C.Backend.html#c:info/0"},{"type":"callback","title":"Circuits.I2C.Backend.open/2","doc":"Open an I2C bus Bus names are typically of the form &quot;i2c-n&quot; and available buses may be found by calling bus_names/1 . Options: :retries - Specify a nonnegative integer for how many times to retry a failed I2C operation.","ref":"Circuits.I2C.Backend.html#c:open/2"},{"type":"type","title":"Circuits.I2C.Backend.options/0","doc":"I2C transfer options Support for options is backend-specific. Backends are encouraged to implement the following: :retries - a number of times to attempt to retry the transaction before failing","ref":"Circuits.I2C.Backend.html#t:options/0"},{"type":"protocol","title":"Circuits.I2C.Bus","doc":"A bus is the connection to a real or virtual I2C controller","ref":"Circuits.I2C.Bus.html"},{"type":"function","title":"Circuits.I2C.Bus.close/1","doc":"Free up resources associated with the bus Well behaved backends free up their resources with the help of the Erlang garbage collector. However, it is good practice for users to call Circuits.I2C.close/1 (and hence this function) so that limited resources are freed before they're needed again.","ref":"Circuits.I2C.Bus.html#close/1"},{"type":"function","title":"Circuits.I2C.Bus.flags/1","doc":"","ref":"Circuits.I2C.Bus.html#flags/1"},{"type":"function","title":"Circuits.I2C.Bus.read/4","doc":"Read data over I2C The controller should try to read the specified number of bytes over I2C. If the retry option is passed and non-zero, the transaction only needs to be retried if there's an error. This means that fewer that the requested number of bytes may be returned. See the implementation for options","ref":"Circuits.I2C.Bus.html#read/4"},{"type":"function","title":"Circuits.I2C.Bus.write/4","doc":"Write data over I2C The controller should write the passed in data to the specified I2C address.","ref":"Circuits.I2C.Bus.html#write/4"},{"type":"function","title":"Circuits.I2C.Bus.write_read/5","doc":"Write data and read a result in one I2C transaction This function handles the common task of writing a register number to a device and then reading its contents. The controller should perform it as one transaction without a stop condition between the write and read.","ref":"Circuits.I2C.Bus.html#write_read/5"},{"type":"type","title":"Circuits.I2C.Bus.flag/0","doc":"I2C controller flags :supports_empty_write - the controller supports sending empty binaries to devices. These can be used for device detection.","ref":"Circuits.I2C.Bus.html#t:flag/0"},{"type":"type","title":"Circuits.I2C.Bus.t/0","doc":"","ref":"Circuits.I2C.Bus.html#t:t/0"},{"type":"module","title":"Circuits.I2C.I2CDev","doc":"Circuits.I2C backend for the Linux i2c-dev interface This backend works on Nerves, embedded Linux, and desktop Linux.","ref":"Circuits.I2C.I2CDev.html"},{"type":"function","title":"Circuits.I2C.I2CDev.bus_names/1","doc":"Return the I2C bus names on this system No supported options","ref":"Circuits.I2C.I2CDev.html#bus_names/1"},{"type":"function","title":"Circuits.I2C.I2CDev.info/0","doc":"Return information about this backend","ref":"Circuits.I2C.I2CDev.html#info/0"},{"type":"function","title":"Circuits.I2C.I2CDev.open/2","doc":"Open an I2C bus Bus names are typically of the form &quot;i2c-n&quot; and available buses may be found by calling Circuits.I2C.bus_names/0 . Options: :retries - Specify a nonnegative integer for how many times to retry a failed I2C operation.","ref":"Circuits.I2C.I2CDev.html#open/2"},{"type":"module","title":"Circuits.I2C.NilBackend","doc":"Circuits.I2C backend when nothing else is available","ref":"Circuits.I2C.NilBackend.html"},{"type":"function","title":"Circuits.I2C.NilBackend.bus_names/1","doc":"Return the I2C bus names on this system No supported options","ref":"Circuits.I2C.NilBackend.html#bus_names/1"},{"type":"function","title":"Circuits.I2C.NilBackend.info/0","doc":"Return information about this backend","ref":"Circuits.I2C.NilBackend.html#info/0"},{"type":"function","title":"Circuits.I2C.NilBackend.open/2","doc":"Open an I2C bus No supported options.","ref":"Circuits.I2C.NilBackend.html#open/2"},{"type":"extras","title":"Circuits.I2C","doc":"Circuits.I2C lets you communicate with hardware devices using the I2C protocol. This is the v2.0 development branch. It's not ready yet. Most users will want to follow the maint-v1.x branch . Circuits.I2C v2.0 is an almost backwards compatible update to Circuits.I2C v1.x. Here's what's new: Linux or Nerves are no longer required. In fact, the NIF supporting them won't be compiled if you don't want it. Develop using simulated I2C devices with CircuitsSim Use USB-&gt;I2C adapters for development on your laptop (Coming soon) If you've used Circuits.I2C v1.x, nearly all of your code will be the same. If you're a library author, we'd appreciate if you could try this out and update your :circuits_i2c dependency to allow v2.0. Details can be found in our porting guide .","ref":"readme.html"},{"type":"extras","title":"Circuits.I2C - Getting started on Nerves and Linux","doc":"By default, Circuits.I2C supports the Linux-based I2C driver interface so the following instructions assume a Linux-based system like Nerves, Raspberry Pi OS, embedded Linux or even desktop Linux if I2C lines are exposed. If you want to use Circuits.I2C on a different platform and support is available, generally the only difference is to change the &quot;open&quot; call. The rest is the same. First off, add circuits_i2c to your mix.exs 's dependency list like any other Elixir library: def deps do [ { :circuits_i2c , &quot;~&gt; 2.0&quot; } ] end Circuits.I2C doesn't load device drivers, so you may need to load them beforehand. If you are using Nerves on a supported platform, this is enabled for you already. If using Raspberry Pi OS, the Adafruit Raspberry Pi I2C instructions may be helpful. Internally, it uses the Linux &quot;i2c-dev&quot; interface so that it does not require board-dependent code.","ref":"readme.html#getting-started-on-nerves-and-linux"},{"type":"extras","title":"Circuits.I2C - Getting started without hardware","doc":"If you don't have any real I2C devices, it's possible to work with simulated devices. See the CircuitsSim project for details.","ref":"readme.html#getting-started-without-hardware"},{"type":"extras","title":"Circuits.I2C - I2C background","doc":"An Inter-Integrated Circuit (I2C) bus supports addressing hardware components and bidirectional use of the data line. The following shows a bus IO expander connected via I2C to the processor. The protocol for talking to the IO expander is described in the MCP23008 Datasheet . Here's a simple example of using it. # On the Raspberry Pi, the IO expander is connected to I2C bus 1 (i2c-1). # Its 7-bit address is 0x20. (see datasheet) iex&gt; alias Circuits.I2C Circuits.I2C iex&gt; { :ok , ref } = I2C . open ( &quot;i2c-1&quot; ) { :ok , # Reference &lt; ... &gt; } # By default, all 8 GPIOs are set to inputs. Set the 4 high bits to outputs # so that we can toggle the LEDs. (Write 0x0f to register 0x00) iex&gt; I2C . write ( ref , 0x20 , &lt;&lt; 0x00 , 0x0f &gt;&gt; ) :ok # Turn on the LED attached to bit 4 on the expander. (Write 0x10 to register # 0x09) iex&gt; I2C . write ( ref , 0x20 , &lt;&lt; 0x09 , 0x10 &gt;&gt; ) :ok # Read all 11 of the expander&#39;s registers to see that the bit 0 switch is # the only one on and that the bit 4 LED is on. iex&gt; I2C . write ( ref , 0x20 , &lt;&lt; 0 &gt;&gt; ) # Set the next register to be read to 0 :ok iex&gt; I2C . read ( ref , 0x20 , 11 ) { :ok , &lt;&lt; 15 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 17 , 16 &gt;&gt; } # The operation of writing one or more bytes to select a register and # then reading is very common, so a shortcut is to just run the following: iex&gt; I2C . write_read ( ref , 0x20 , &lt;&lt; 0 &gt;&gt; , 11 ) { :ok , &lt;&lt; 15 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 17 , 16 &gt;&gt; } # The 17 in register 9 says that bits 0 and bit 4 are high # We could have just read register 9. iex&gt; I2C . write_read ( ref , 0x20 , &lt;&lt; 9 &gt;&gt; , 1 ) { :ok , &lt;&lt; 17 &gt;&gt; }","ref":"readme.html#i2c-background"},{"type":"extras","title":"Circuits.I2C - Creating a new backend","doc":"Circuits.I2C supports alternative backends to support non-Linux hardware, testing, and simulation. A backend can support communication on more than one I2C bus. To create a new backend, you need to implement the Circuits.I2C.Backend behaviour. Circuits.I2C calls the bus_names/1 callback to discover what I2C buses are available and then it calls the open/2 callback to use the I2C bus.","ref":"readme.html#creating-a-new-backend"},{"type":"extras","title":"Circuits.I2C - FAQ","doc":"How do I debug? The most common issue is communicating with an I2C for the first time. For I2C, first check that an I2C bus is available: iex&gt; Circuits.I2C . bus_names [ &quot;i2c-1&quot; ] If the list is empty, then I2C is either not available, not enabled, or not configured in the kernel. If you're using Raspbian, run raspi-config and check that I2C is enabled in the advanced options. If you're on a BeagleBone, try running config-pin and see the Universal I/O project to enable the I2C pins. On other ARM boards, double check that I2C is enabled in the kernel and that the device tree configures it. Once an I2C bus is available, try detecting devices on it: iex&gt; Circuits.I2C . detect_devices ( ) Circuits.I2C . detect_devices Devices on I2C bus &quot;i2c-1&quot; : * 64 ( 0x40 ) * 112 ( 0x70 ) 2 devices detected on 1 I2C buses The return value here is a list of device addresses that were detected. It is still possible that the device will work even if it does not detect, but you probably want to check wires at this point. If you have a logic analyzer, use it to verify that I2C transactions are being initiated on the bus. I2C seems slow. What could be wrong? I2C buses are usually run at 100 kbit/s or 400 kbit/s. Many devices support higher speeds. The tradeoff is that higher speeds are sometimes don't work as well especially if you're using jumper cables to connect parts together. The Raspberry Pi runs the I2C bus at a low speed - probably for this reason. Other things to check: Can you reduce the reads and writes? I2C devices let you read or write many bytes at the same time. Each transaction has overhead so minimizing transaction helps. Can you reduce the total number of bytes in each transaction? For example, do you need to read a particular register? Is there a mode that the device can be put it so that it only returns useful data? Can a write and read be combined? The Circuits.I2C.write_read function is more efficient than a separate write followed by a read. Does the device support a queue mode? Some devices have internal queues that allow the host to copy out more than one sample each time. Where can I get help? The hardest part is communicating with a device for the first time. The issue is usually unrelated to Circuits.I2C . If you expand your searches to include Python and C forums, you'll frequently find the answer. If that fails, try posting a question to the Elixir Forum . Tag the question with Nerves and it will have a good chance of getting to the right people. Feel free to do this even if you're not using Nerves. Can I develop code that uses Circuits.I2C on my laptop? You have a few options: Connect your I2C devices to a USB-&gt;I2C adapter like a Adafruit FT232H Breakout Use the CircuitsSim backend Create a custom backend and use it to mock interactions with the Circuits.I2C API Will it run on Arduino? No. This only runs on Linux-based boards. If you're interested in controlling an Arduino from a computer that can run Elixir, check out circuits_uart for communicating via the Arduino's serial connection or firmata for communication using the Arduino's Firmata protocol.","ref":"readme.html#faq"},{"type":"extras","title":"Circuits.I2C - License","doc":"Code from the library is licensed under the Apache License, Version 2.0.","ref":"readme.html#license"},{"type":"extras","title":"Porting","doc":"","ref":"porting.html"},{"type":"extras","title":"Porting - Upgrading Circuits.I2C 1.0 projects to 2.0","doc":"Circuits.I2C 2.0 supports alternative I2C hardware and the ability to mock or emulate devices via backends. The Linux i2c-dev backend is the default and this matches Circuits.I2C 1.0. Most projects won't need any changes other than to update the dependency in mix.exs . If upgrading a library, The following dependency specification is recommended to allow both circuits_i2c versions: { :circuits_i2c , &quot;~&gt; 2.0 or ~&gt; 1.0&quot; } The following potentially breaking changes were made: Circuits.I2C.open/1 no longer accepts Erlang strings. The stub implementation has been renamed to i2c_dev_test . If using the stub implementation for testing, you may have to update your tests since there were minor changes.","ref":"porting.html#upgrading-circuits-i2c-1-0-projects-to-2-0"},{"type":"extras","title":"Porting - Upgrading Elixir/ALE projects to Circuits.I2C","doc":"The Circuits.I2C package is the next version of Elixir/ALE's I2C support. If you're currently using Elixir/ALE, you're encouraged to switch. Here are some benefits: Supported by both the maintainer of Elixir/ALE and a couple others. They'd prefer to support Circuits.I2C issues. Much faster than Elixir/ALE. Simplified API Circuits.I2C uses Erlang's NIF interface. NIFs have the downside of being able to crash the Erlang VM. Experience with Elixir/ALE has given many of us confidence that this won't be a problem. Code modifications Circuits.I2C is not a GenServer , so if you've added ElixirALE.I2C to a supervision tree, you'll have to take it out and manually call Circuits.I2C.open to obtain a reference. A common pattern is to create a GenServer that is descriptive of what the I2C device does and have it be responsible for all I2C calls. The remain modifications should mostly be mechanical: Rename references to ElixirALE.I2C to Circuits.I2C and elixir_ale to circuits_i2c Change calls to ElixirALE.I2C.start_link/2 to Circuits.I2C.open/1 . You'll need to remove the I2C address from the call to open. While you're at it, review the arguments to open to not include any GenServer options. Add the I2C device's bus address to all of the read , write , and write_read calls. We recommend making a short helper function that has the I2C address. The read and write_read functions now return {:ok, result} tuples on success so add code to handle that. Alternately, call read! or write_read! and they will raise an exception if there's an error. Look for calls to I2C.read_device , I2C.write_device and I2C.write_read_device and remove the _device part. Consider adding a call to Circuits.I2C.close/1 if there's an obvious place to release the I2C. This is not strictly necessary since the garbage collector will free unreferenced I2C references. If you manually implemented I2C bus retry logic, consider specifying the :retries option to have Circuits.I2C retry for you. Change calls to ElixirALE.I2C.device_names/0 to Circuits.I2C.bus_names/0 . If you find that you have to make any other changes, please let us know via an issue or PR so that other users can benefit.","ref":"porting.html#upgrading-elixir-ale-projects-to-circuits-i2c"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - v2.0.0-pre.0 - 2023-05-30","doc":"This is a major update to Circuits.I2C that removes the requirement to use Nerves or Linux. The API is almost the same and the default is to compile and use the Linux backend, so changes may not be needed. This is a prerelease so APIs may still change before the v2.0.0 release. Changes Support alternative backends for different operating systems or for simulated hardware For the Linux NIF, support passing a :retry count to Circuits.I2C.open/2 that will apply to all I2C operations. This simplifies dealing with devices with flaky connections. Defer loading the Linux NIF until Circuits.I2C.open/2 is called Return error on Circuits.I2C.open/2 if the device isn't a real I2C device. This was previously detected on the first operation. For the Linux NIF, return errno numbers rather than their strerr strings when they're unknown. It turned out that the strings could be more confusing that the numbers.","ref":"changelog.html#v2-0-0-pre-0-2023-05-30"},{"type":"extras","title":"Changelog - v1.2.2 - 2023-03-24","doc":"Fixes Add types.h compatibility header to hex package so that host MacOS builds work again.","ref":"changelog.html#v1-2-2-2023-03-24"},{"type":"extras","title":"Changelog - v1.2.1 - 2023-03-20","doc":"Fixes Detect I2C controllers that don't support 0-byte writes and revert to the old detection heuristic. This fixes an issue on Beaglebones (AM335x) that caused devices to be missed and kernel warnings to be logged.","ref":"changelog.html#v1-2-1-2023-03-20"},{"type":"extras","title":"Changelog - v1.2.0 - 2023-03-17","doc":"Changes Improve device detection by using 0-byte writes on some I2C addresses and 1-byte reads on others. This matches the i2c-tools heuristic and detects at least on more device that wasn't detected before. Simplified NIF by deleting a lot of flexibility that didn't end up being useful. Also moved functionality around so that it could be implemented more simply.","ref":"changelog.html#v1-2-0-2023-03-17"},{"type":"extras","title":"Changelog - v1.1.0 - 2022-11-16","doc":"Changes Immediately close I2C bus references after discovery. Waiting for the GC to collect them could cause intermittent failures in rare scenarios where multiple I2C device discoveries are done close together. This likely only affects CI in practice. Remove Erlang convenience functions since no one used them Require Elixir 1.10 or later. Previous versions probably work, but won't be supported. This opens up the possibility of using Elixir 1.10+ features in future releases.","ref":"changelog.html#v1-1-0-2022-11-16"},{"type":"extras","title":"Changelog - v1.0.1 - 2021-12-28","doc":"Fixes Properly mark I/O bound functions in NIF.","ref":"changelog.html#v1-0-1-2021-12-28"},{"type":"extras","title":"Changelog - v1.0.0 - 2021-10-20","doc":"This release only changes the version number. No code has changed.","ref":"changelog.html#v1-0-0-2021-10-20"},{"type":"extras","title":"Changelog - v0.3.9","doc":"This release only has doc and build output cleanup. No code has changed.","ref":"changelog.html#v0-3-9"},{"type":"extras","title":"Changelog - v0.3.8","doc":"New features Add Circuits.I2C.discover/2 and Circuits.I2C.discover_one/2 . These functions are intended for library authors wanting to provide good suggestions or defaults to their users. See the hex docs for more information. Thanks to Bruce Tate for the idea and PR. Improvements The stub I2C implementation is now used whenever MIX_ENV=test . While this is not generally useful for testing code that uses Circuits.I2C, it does prevent accidental use of real I2C buses in unit tests on those systems with real I2C buses.","ref":"changelog.html#v0-3-8"},{"type":"extras","title":"Changelog - v0.3.7","doc":"Improvements Add I2C address in hex showing detected devices","ref":"changelog.html#v0-3-7"},{"type":"extras","title":"Changelog - v0.3.6","doc":"Bug fixes Add -fPIC to compilation flags to fix build with nerves_system_x86_64 and other environments using the Musl C toolchains","ref":"changelog.html#v0-3-6"},{"type":"extras","title":"Changelog - v0.3.5","doc":"Bug fixes Reduce the number of I2C addresses scanned for detection to avoid confusing some devices.","ref":"changelog.html#v0-3-5"},{"type":"extras","title":"Changelog - v0.3.4","doc":"This release should work on Erlang/OTP 20 - 22 and Elixir 1.4 and newer. The CI process has been updated to verify more versions now. Bug fixes Improve error message when bus doesn't exist","ref":"changelog.html#v0-3-4"},{"type":"extras","title":"Changelog - v0.3.3","doc":"Bug fixes Fix binary handling in NIF. This fixes segfaults and other errors when run on Raspbian.","ref":"changelog.html#v0-3-3"},{"type":"extras","title":"Changelog - v0.3.2","doc":"Bug fixes Fix file handle leak when I2C bus references were garbage collected.","ref":"changelog.html#v0-3-2"},{"type":"extras","title":"Changelog - v0.3.1","doc":"Bug fixes Build C source under the _build directory so that changing targets properly rebuilds the C code as well as the Elixir code.","ref":"changelog.html#v0-3-1"},{"type":"extras","title":"Changelog - v0.3.0","doc":"Print detected devices instead of an error.","ref":"changelog.html#v0-3-0"},{"type":"extras","title":"Changelog - v0.2.0","doc":"Minor text updates. Remove i2c_ from i2c_address and i2c_bus.","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"Changelog - v0.1.0","doc":"Initial release to hex.","ref":"changelog.html#v0-1-0"}]